diff --git a/sway/tree/view.c b/sway/tree/view.c
index ca13def724..16103ba249 100644
--- a/sway/tree/view.c
+++ b/sway/tree/view.c
@@ -54,6 +54,7 @@ void view_destroy(struct sway_view *view) {
 	}
 	list_free(view->executed_criteria);
 
+	view->xdg_decoration->view = NULL;
 	free(view->title_format);
 
 	if (view->impl->destroy) {
diff --git a/sway/xdg_decoration.c b/sway/xdg_decoration.c
index 39e0df5641..9ac87191da 100644
--- a/sway/xdg_decoration.c
+++ b/sway/xdg_decoration.c
@@ -10,7 +10,9 @@ static void xdg_decoration_handle_destroy(struct wl_listener *listener,
 		void *data) {
 	struct sway_xdg_decoration *deco =
 		wl_container_of(listener, deco, destroy);
-	deco->view->xdg_decoration = NULL;
+	if(deco->view) {
+		deco->view->xdg_decoration = NULL;
+	}
 	wl_list_remove(&deco->destroy.link);
 	wl_list_remove(&deco->request_mode.link);
 	wl_list_remove(&deco->link);
